> This page is for Afterpay Online Developer, version Main (default).
> For other versions, use one of these documentation indexes:
> - Main (default): https://developers.afterpay.com/afterpay-online-developer/main/llms.txt
> - v1: https://developers.afterpay.com/afterpay-online-developer/v-1/llms.txt
> - Chinese: https://developers.afterpay.com/afterpay-online-developer/chinese/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.afterpay.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.afterpay.com/_mcp/server.

# Retrieve Billing Agreement Offers

POST https://global-api-sandbox.afterpay.com/v2/billing-agreements/offers
Content-Type: application/json

Retrieves available offers for billing agreements based on amount and frequency.

*Deprecated. For new integrations, see [Grants](https://afterpay.docs.buildwithfern.com/afterpay-online-developer/api-reference/reference/grants/start-grant-approval).*

Reference: https://developers.afterpay.com/afterpay-online-developer/api-reference/reference/billing-agreements-deprecated/retrieve-billing-agreement-offers

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Servers

- `https://global-api-sandbox.afterpay.com` (Sandbox, default)
- `https://global-api.afterpay.com` (Production)

## Request

### Headers

- `Accept` (string, optional, default: application/json)

### Body (application/json)

This endpoint expects an OffersRequest.

- `requestId` (string, required) — A unique identifier for this request
- `amount` (Money, required) — The amount to check offers for
- `token` (string, required) — The billing agreement token

## Response

### 200

Offers retrieved successfully

- `consumerMaskedEmail` (string, optional) — Masked email address of the consumer
- `consumerAmount` (Money, optional) — Amount in consumer's currency
- `offers` (list of Offer, optional) — List of available offers details

## Errors

### 401 Unauthorized Error

Authentication failed or insufficient permissions. | errorCode | Description | | --- | --- | | unauthorized | The API credentials are invalid or missing. |

- `any`

### 403 Forbidden Error

| errorCode | Description | | --- | --- | | billing_agreement_not_authorised | Recurring payments are not enabled for this merchant. |

- `any`

### 422 Unprocessable Entity Error

| errorCode | Description | | --- | --- | | invalid_object | One or more required fields in the request body were missing or invalid. |

- `any`

## Types

### Money

Object containing amount and currency. Where a Money object is included in an API request, it will be validated according to the specification above. Invalid Money objects will trigger a **422 Unprocessable Entity response**. The following is a list of common examples: | Example | errorCode | message | | ------------------------------------------------------------------------------- | ---------------------- | ------------------------------------------------------------------------- | | `amount` is omitted or null | invalid\_object | \{Money object}.amount Amount field required | | `amount` has more than 2 decimal places | invalid\_object amount | must be a valid ISO 4217 format value | | `amount` includes a thousands separator comma, for example: "1,000" | invalid\_amount | Amount must be a valid ISO 4217 format value | | `amount` is not a decimal number, for example: "FREE", "\$2" or an empty string | invalid\_object | \{Money object}.amount Amount field must be a valid ISO 4217 format value | | `currency` is omitted or null | invalid\_object | \{Money object}.currency Currency field required | | `currency` is not a valid currency code, not all uppercase or an empty string | invalid\_object | \{Money object}.currency Currency not supported for this merchant | | `currency` is supported by Afterpay, but not valid for the Merchant account | unsupported\_currency | An error occurred |

- `amount` (string, required) — The amount as a string representation of a decimal number, rounded to 2 decimal places.
- `currency` (enum, required) — The currency in ISO 4217 format. The value provided must correspond to the currency of the merchant account making the request.
  - Allowed values: `AUD`, `NZD`, `USD`, `CAD`, `GBP`

### Offer

Represents an offer with payment details

- `type` (enum, optional) — Type of the offer
  - Allowed values: `PAY_IN_4`
- `merchantAmount` (Money, optional) — Amount for the merchant
- `exchangeRate` (double, optional) — Exchange rate for cross-border transactions
- `amountDueToday` (Money, optional) — Amount due for immediate payment
- `payments` (list of PaymentSchedule, optional) — List of scheduled payments
- `crossBorder` (boolean, optional) — Indicates if this is a cross-border transaction
- `appliedPromotion` (Money, optional) — Amount of promotion applied
- `consumer` (ConsumerOffers, optional) — Consumer offer details

### PaymentSchedule

Represents a scheduled payment installment

- `amount` (Money, required) — Amount for this payment installment
- `dueDate` (string, required) — Due date for this installment

### ConsumerOffers

Consumer offers

- `noPaymentUpfront` (ConsumerOffersNoPaymentUpfront, optional) — Information about the no payment upfront feature eligibility

### ConsumerOffersNoPaymentUpfront

Information about the no payment upfront feature eligibility

- `eligible` (boolean, required) — Indicates if the consumer is eligible for no payment upfront
- `eligibilityLimit` (Money, required) — The maximum amount eligible for no payment upfront

## Examples

**Request**

```json
{
  "requestId": "123e4567-e89b-12d3-a456-426614174000",
  "amount": {
    "amount": "200.00",
    "currency": "USD"
  },
  "token": "005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2"
}
```

**Response**

```json
{
  "consumerMaskedEmail": "j***@e***.com",
  "consumerAmount": {
    "amount": "200.00",
    "currency": "USD"
  },
  "offers": [
    {
      "type": "PAY_IN_4",
      "merchantAmount": {
        "amount": "200.00",
        "currency": "USD"
      },
      "exchangeRate": 1.35,
      "amountDueToday": {
        "amount": "50.00",
        "currency": "USD"
      },
      "payments": [
        {
          "amount": {
            "amount": "50.00",
            "currency": "USD"
          },
          "dueDate": "2024-03-04"
        },
        {
          "amount": {
            "amount": "50.00",
            "currency": "USD"
          },
          "dueDate": "2024-03-18"
        },
        {
          "amount": {
            "amount": "50.00",
            "currency": "USD"
          },
          "dueDate": "2024-04-01"
        },
        {
          "amount": {
            "amount": "50.00",
            "currency": "USD"
          },
          "dueDate": "2024-04-15"
        }
      ],
      "crossBorder": false,
      "appliedPromotion": {
        "amount": "20.00",
        "currency": "USD"
      },
      "consumer": {
        "noPaymentUpFront": {
          "eligible": true,
          "eligibilityLimit": {
            "amount": "2000.00",
            "currency": "USD"
          }
        }
      }
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://global-api-sandbox.afterpay.com/v2/billing-agreements/offers"

payload = {
    "requestId": "123e4567-e89b-12d3-a456-426614174000",
    "amount": {
        "amount": "200.00",
        "currency": "USD"
    },
    "token": "005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2"
}
headers = {
    "User-Agent": "User-Agent"
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, auth=("<username>", "<password>"))

print(response.json())
```

```javascript
const url = 'https://global-api-sandbox.afterpay.com/v2/billing-agreements/offers';
const credentials = btoa("<username>:<password>");

const options = {
  method: 'POST',
  headers: {
    'User-Agent': 'User-Agent',
    Authorization: `Basic ${credentials}`,
    'Content-Type': 'application/json'
  },
  body: '{"requestId":"123e4567-e89b-12d3-a456-426614174000","amount":{"amount":"200.00","currency":"USD"},"token":"005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://global-api-sandbox.afterpay.com/v2/billing-agreements/offers"

	payload := strings.NewReader("{\n  \"requestId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"amount\": {\n    \"amount\": \"200.00\",\n    \"currency\": \"USD\"\n  },\n  \"token\": \"005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("User-Agent", "User-Agent")
	req.SetBasicAuth("<username>", "<password>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://global-api-sandbox.afterpay.com/v2/billing-agreements/offers")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["User-Agent"] = 'User-Agent'
request.basic_auth("<username>", "<password>")
request["Content-Type"] = 'application/json'
request.body = "{\n  \"requestId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"amount\": {\n    \"amount\": \"200.00\",\n    \"currency\": \"USD\"\n  },\n  \"token\": \"005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://global-api-sandbox.afterpay.com/v2/billing-agreements/offers")
  .header("User-Agent", "User-Agent")
  .basicAuth("<username>", "<password>")
  .header("Content-Type", "application/json")
  .body("{\n  \"requestId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"amount\": {\n    \"amount\": \"200.00\",\n    \"currency\": \"USD\"\n  },\n  \"token\": \"005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://global-api-sandbox.afterpay.com/v2/billing-agreements/offers', [
  'body' => '{
  "requestId": "123e4567-e89b-12d3-a456-426614174000",
  "amount": {
    "amount": "200.00",
    "currency": "USD"
  },
  "token": "005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'User-Agent' => 'User-Agent',
  ],
    'auth' => ['<username>', '<password>'],
]);

echo $response->getBody();
```

```csharp
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://global-api-sandbox.afterpay.com/v2/billing-agreements/offers");
client.Authenticator = new HttpBasicAuthenticator("<username>", "<password>");
var request = new RestRequest(Method.POST);
request.AddHeader("User-Agent", "User-Agent");

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"requestId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"amount\": {\n    \"amount\": \"200.00\",\n    \"currency\": \"USD\"\n  },\n  \"token\": \"005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let credentials = Data("<username>:<password>".utf8).base64EncodedString()

let headers = [
  "User-Agent": "User-Agent",
  "Authorization": "Basic \(credentials)",
  "Content-Type": "application/json"
]
let parameters = [
  "requestId": "123e4567-e89b-12d3-a456-426614174000",
  "amount": [
    "amount": "200.00",
    "currency": "USD"
  ],
  "token": "005.2fkv5o963b132z8ppa34srlh60987y87d55re237wsg9tr4q2"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://global-api-sandbox.afterpay.com/v2/billing-agreements/offers")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```